#    .   
#    18  2002
#       2002-12-20 --       
#                      
#                      c 
#                          
#       2003-12-25 --    2003 
#       2003-12-28 --    res-best (     )

#  CITIES.TXT   
#   nnnnn-I.TXT  nnnnn-R.TXT -  

#   -     

#  :
#     $number -  
#     $name{$number} - 
#     $age{$number} - 
#     $cap {$number} - 
#     $city{$number} - 
#     $sum{$number} - 
#
#     @{%group[$sum]} -     
#

#  
require 'charset.pl';

#   
require 'proc.pl';

#    
require 'resparam.pl';

#---------------------------------------------------------------------

(open CITIES, "cities.txt") || die "CITIES.txt: $!\n";
while (<CITIES>) {
   ($code, @cityname) = split;
   $maincity = join ' ', @cityname;

      $f = "$indir\\${code}-I.TXT";
      next unless -e $f;
      (open  IN, $f) || die "$f: $!\n";
      $in_charset = setcode($_ = <IN>);
      $_ = <IN>;   #   1  

      while (<IN>) {
         next if /^\s*$/ || /^\s*%/ || /^\s*\d/;
         $_ = russian($_, $in_charset, $innercode);
         ($teamcode, $teamage, $teamname, $teamcap, $teamcity) = split /\s*[|:]\s*/;
         $name{$teamcode} = $teamname;
         $age{$teamcode} = $agename{$teamage};
         $cap{$teamcode} = $teamcap;
         $city{$teamcode} = $teamcity || $maincity;
      }
      close IN;

      $f = "$indir\\${code}-R.TXT";
      next unless -e $f;
      (open  IN, $f) || die "$f: $!\n";
      $in_charset = setcode($_ = <IN>);
      $_ = <IN>;   #   1  

      while (<IN>) {
         next if /^\s*$/ || /^\s*%/;
         $_ = russian($_, $in_charset, $innercode);
         ($tour,$teamcode,@result) = split;
         $sum = pop @result;
         $string = join '',@result;
         for $q (@qbad) {
            next unless $nq*($tour-1) < $q && $q <= $nq*$tour;
            $sum-- if substr($string, ($q-1) % $nq, 1, 'X') eq '+';
         }
         $sum{$teamcode} += $sum;
         push @{$grtour{all}[$tour][$sum]}, $teamcode;
         push @{$grtour{$age{$teamcode}}[$tour][$sum]}, $teamcode;
         $qtab{$teamcode}[$tour-1] = $string;
      }
      close IN;
}
close CITIES;

for $age (keys %grtour) {
   for $tour (1..$#{$grtour{$age}}) {
      $place1 = 1;
      for $s (reverse (0..$#{$grtour{$age}[$tour]})) {
         if (($cnt = scalar @{$grtour{$age}[$tour][$s]}) == 1) {
            $place = $place1;
         } else {
            $place2 = $place1 + $cnt - 1;
            $place = ($place1 + $place2) / 2;
         }
         for (sort @{$grtour{$age}[$tour][$s]}) {
            $sumplace{$age}{$_} += $place;
         }
         $place1 += $cnt;
      }
   }
}


for (keys %sum) {
   push @{$grp{all}{sprintf "%2d%6.1f", $sum{$_}, 10000-$sumplace{all}{$_}}}, $_;
   push @{$grp{$age{$_}}{sprintf "%2d%6.1f", $sum{$_}, 10000-$sumplace{$age{$_}}{$_}}}, $_;

   ($country, $region) = /^(\w\w)(\w\w)/;
   if ($sum{$_} > $max{$country}{$region}) {
      $max{$country}{$region} = $sum{$_};
      @{$best{$country}{$region}} = ();
   }
   if ($sum{$_} == $max{$country}{$region}) {
      push @{$best{$country}{$region}},$_;
   }
}

open BEST, ">$outdir\\res-best.txt";
for $country (sort keys %max) {
   for $region (sort {$max{$country}{$b} <=> $max{$country}{$a}} keys %{$max{$country}}) {
      for (@{$best{$country}{$region}}) {
         write BEST;
      }
   }
   print BEST "\n";
}

format BEST = 
@#   @<<<<<<<   @<<<<<<<<<<<<<<<<<<<<  @<<<<<<<<<<<<<<<<<<<<<<<<  @*
$sum{$_},  $_, $city{$_},  $cap{$_},        $name{$_},               
.



for $age (keys %grp) {
   open OUT, ">$outdir\\$outfile$age.txt";
   open RES1, ">$outdir\\$outfile1$age.txt";
   select OUT;
   %group = %{$grp{$age}};

   print 
"        S                                    \n";
   print '-'x83,"\n";
   $place1 = 1;
   for $s (sort {$b cmp $a} keys %group ) {
      if (($cnt = scalar @{$group{$s}}) == 1) {
         $~ = OUT1;
      } else {
         $place2 = $place1 + $cnt - 1;
         $~ = OUT2;
      }
      for (sort @{$group{$s}}) {
         $cap{$_} =~ /(.?)\S*\s*(.*)/;
         $teamcap = $2 ? "$1.$2" : $1 ? $cap{$_} : '';
         write OUT;
         write RES1;
      }
      $place1 += $cnt;
   }
   close OUT;
}

format OUT1 = 
  @###      @#   @###.#  @<<<<<<<   @<<<<<<<<<<<<<<<<<<<<  @<<<<<<<<<<<<<<< @*
$place1,  $sum{$_},  $sumplace{$age}{$_}, $_, $city{$_},  $teamcap,        $name{$_},               
.

format OUT2 =
@###-@###   @#   @###.#  @<<<<<<<   @<<<<<<<<<<<<<<<<<<<<  @<<<<<<<<<<<<<<< @*
$place1,$place2,$sum{$_}, $sumplace{$age}{$_}, $_,$city{$_}, $teamcap, $name{$_},
.

format RES1 = 
%  @<<<<<<<<<<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @<<<<<<<<<<<<<<<<
   $cap{$_},            $city{$_},                       $name{$_},
@<<<<<<<  @<<<<<<<<<<< @<<<<<<<<<<< @<<<<<<<<<<< @<<<<<<<<<<<  @#
$_,     @{$qtab{$_}},                                         $sum{$_}, 
.
